#include <Etk.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef MAIN_H_
#define MAIN_H_

struct _Setting_with_entry {
	Etk_Widget	*setting_label,
				*entry,
				*button;
	char		*e_switch,
				*label,
				*help_text;
};
typedef struct _Setting_with_entry Setting_with_entry;

struct _Setting_with_buttons {
	Etk_Widget	*setting_label,
				*button_add,
				*button_substract;
	double		difference,
				minimum;
	char		*e_switch,
				*label,
				*help_text;
};
typedef struct _Setting_with_buttons Setting_with_buttons;

Setting_with_entry *
new_setting_with_entry(char *label, char *e_switch, char *help_text);

Setting_with_buttons *
new_setting_with_buttons(char *label, char *e_switch, char *help_text, double diff, double min);

Etk_Widget	*_openWindow,
			*_modules,
			*_display,
			*_menu,
			*_windows,
			*_winlist,
			*_focus,
			*_transient,
			*get_prepared_toggle_button(char *option);

char*	_raw_command;

void	clicked(void *data),
		sub_window_kill(),
		setting_switch(Etk_Object *object, void *data),
		setting_swe(Etk_Object *object, void *data),
		setting_swb(Etk_Object *object, void *data);
char*	get_raw_command();
char*	getSetting(char* option);
int		setOption(char *option, const char *setting);
int		add_to_root_table(Etk_Widget* table, const char* label, const char* help, Etk_Widget* content, int row);
int		add_to_root_table_swe(Etk_Widget* table, Setting_with_entry *setting, int row);
int		add_to_root_table_swb(Etk_Widget *table, Setting_with_buttons *settings, int row);
#endif /*MAIN_H_*/
